#! /bin/sh

#
# Clean kubernetes pods stuck in "Terminating" state
#
# Example:
#
# k8s-pods-cleaner.sh hub app=jupyterhub,component=singleuser-server --yes
#

if [ -z "$1" ]; then
	echo "Usage: $0 NAMESPACE [QUERY [--yes]]"
	exit 0
fi

NS="$1"
QUERY="$2"
PERFORM="$3"
for pod in $(kubectl get pod -n "$NS" -l "$QUERY" --field-selector="status.phase==Failed" -ojsonpath='{.items[*].metadata.name}'); do
	if [ -n "$PERFORM" ]; then
		kubectl get pod -n "$NS" "$pod" -oyaml > "/tmp/$NS-$pod.yaml"
		kubectl delete pod -n "$NS" "$pod" --force
	else
		kubectl get pod -n "$NS" "$pod"
	fi
done
